
#include "unix.h"
#include "off.h"


static int strbpos( s, c )
char *s, c;
{ 
    int i = -1; 
    int l = strlen( s ); 
    for( i=l-1; i>=0; i-- )
        if( s[i] == c )
            return i;
    return i;
}


int strin( s, c )
char *s, *c;
{
    int i;
    int ls, lc;

    ls = strlen( s );
    lc = strlen( c );

    for( i=0; i<lc; i++ ) {
        if( s[ls-1-i] != c[lc-1-i] )
            return 0;
    }
    return 1;
}


processFile( some_file )
char *some_file;
{
    int n_some_file = 0;

    struct stat s_buf;
    char *_file = (char *)NULL;
    char *aoff_file = (char *)NULL;
    char *geom_file = (char *)NULL;

    FILE *fp;
    extern char *FileName;

    char *path = (char *)NULL;
    char *path_aoff_file = (char *)NULL;
    char *path_geom_file = (char *)NULL;

    some_file += strbpos( some_file, '/' ) + 1;
    some_file[strlen(some_file)] = '\0';
    n_some_file = strlen(some_file);

         if( strin( some_file, "aoff" ) ) {
        if( (_file = (char *)malloc(n_some_file)) == (char *)0 ) {
            fprintf( stderr, "Cant allocate char\n" );
            exit(1);
        }
        strncpy( _file, some_file, n_some_file-4 );
        _file[n_some_file-4] = '\0';
    }
    else if( strin( some_file, "bgeom" ) ) {
        if( (_file = (char *)malloc(n_some_file)) == (char *)0 ) {
            fprintf( stderr, "Cant allocate char\n" );
            exit(1);
        }
        strncpy( _file, some_file, n_some_file-5 );
        _file[n_some_file-5] = '\0';
    }
    else if( strin( some_file, "geom" ) ) {
        if( (_file = (char *)malloc(n_some_file)) == (char *)0 ) {
            fprintf( stderr, "Cant allocate char\n" );
            exit(1);
        }
        strncpy( _file, some_file, n_some_file-4 );
        _file[n_some_file-4] = '\0';
    }
    else if( strin( some_file, "pnorm" ) ) {
        if( (_file = (char *)malloc(n_some_file)) == (char *)0 ) {
            fprintf( stderr, "Cant allocate char\n" );
            exit(1);
        }
        strncpy( _file, some_file, n_some_file-5 );
        _file[n_some_file-5] = '\0';
    }
    else if( strin( some_file, "vnorm" ) ) {
        if( (_file = (char *)malloc(n_some_file)) == (char *)0 ) {
            fprintf( stderr, "Cant allocate char\n" );
            exit(1);
        }
        strncpy( _file, some_file, n_some_file-5 );
        _file[n_some_file-5] = '\0';
    }
    else if( strin( some_file, "fly" ) ) {
        if( (_file = (char *)malloc(n_some_file)) == (char *)0 ) {
            fprintf( stderr, "Cant allocate char\n" );
            exit(1);
        }
        strncpy( _file, some_file, n_some_file-3 );
        _file[n_some_file-3] = '\0';
    }
    else {
        fprintf( stderr,
                 "Error file \"%s\" -- Incorrect or invalid extension\n",
                 some_file );
        return 0;
    }
    _file[strlen(_file)-1] = '\0';

    if( (aoff_file = (char *)malloc( strlen(_file) + 10 )) == (char *)0 ) {
        fprintf( stderr, "Cant allocate char\n" );
        exit(1);
    }
    strcpy( aoff_file, _file );
    strcat( aoff_file, ".aoff" );	/**/

    if( (geom_file = (char *)malloc( strlen(_file) + 10 )) == (char *)0 ) {
        fprintf( stderr, "Cant allocate char\n" );
        exit(1);
    }
    strcpy( geom_file, _file );
    strcat( geom_file, ".geom" );	/**/

    if( (path = (char *)malloc( strlen(getenv("OBJ_PATH")) + 1 )) ==
        (char *)0 ) {
        fprintf( stderr, "Cant allocate char\n" );
        exit(1);
    }
    strcpy( path, getenv("OBJ_PATH") );
    strcat( path, "/" );

    if( (path_aoff_file = (char *)malloc( strlen(path) + strlen(aoff_file) +1 ))
     == (char *)0 ) {
        fprintf( stderr, "Cant allocate char\n" );
        exit(1);
    }
    strcpy( path_aoff_file, path );
    strcat( path_aoff_file, aoff_file );

    if( (path_geom_file = (char *)malloc( strlen(path) + strlen(geom_file) +1 ))
     == (char *)0 ) {
        fprintf( stderr, "Cant allocate char\n" );
        exit(1);
    }
    strcpy( path_geom_file, path );
    strcat( path_geom_file, geom_file );

    /* if file can't be accessed ( via stat(  ) ) return. */
    if( stat( path_aoff_file, &s_buf ) == -1 ) {
        if( (fp = fopen( path_aoff_file, "a" )) == (FILE *)NULL ) {
            printf( "Error -- %s does not exist 2\n", aoff_file );
            exit( 1 );
        }
        if( stat( path_geom_file, &s_buf ) == -1 ) {
            if( (geom_file = (char *)malloc( strlen(_file) + 10 )) ==
                (char *)0 ) {
                fprintf( stderr, "Cant allocate char\n" );
                exit(1);
            }
            strcpy( geom_file, _file );
            strcat( geom_file, ".bgeom" );
        }
        fprintf( fp, "\ngeometry\t\tindexed_poly\tfff\t\t%s\n", geom_file );
        fclose( fp );
        getNormals( path, _file );
    }
    FileName = aoff_file;
    return 1;
}
